#include "io430.h"
#include "in430.h"
#include "function.h"

unsigned char data;//podatak koji se ispisuje na displej
unsigned int result;

int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;
  P4DIR=0xFE;//segmenti
  P5DIR=0x80;//selektovan prvi displej
  P5OUT=0x80;//ukljucen prvi displej
  P1IE=0x04;//dozvola prekida za taster S4
  P1IES=0x04;//opadajuca ivica aktivira prekid  
  P2SEL|=0x30;//funkcija pinova 4 i 5 porta 2 dodeljena uart-u
  ME1|=URXE0+UTXE0;//omogucavanje UART prijemnik i predajnik
  U0CTL=0x10;//8-bit characters
  U0TCTL=0x30;//UCLK = SMCLK
  U0BR0=0xB5;// 1,048576/2400  436.9=437=0x1B5
  U0BR1=0x01;
  IE1=0x40;
  
  P6SEL |= 0x10;                            // Enable A/D channel A4
  ADC12CTL0 = ADC12ON+SHT0_15;              // Turn on ADC12, set sampling time
  ADC12CTL1 = SHP;                          // Use sampling timer, set mode
  ADC12MCTL0 = INCH_4;                      // channel A4
  ADC12IE = 0x01;                           // Enable ADC12IFG.0
  ADC12CTL0 |= ENC;                         // Enable conversions

  
  _EINT();//funkcija dekalrisana u i430.h - globalna dozvola prekida
  while(1);
}

// define the interrupt handler
#pragma vector=PORT1_VECTOR
__interrupt void port1Handler( void ){
  U0TXBUF=data;//na pritisak tastera salje podatak
  P1IFG=P1IFG&~BIT2;//brise flag na pozicija bita 2
};

// define the interrupt handler
#pragma vector=UART0RX_VECTOR
__interrupt void uart0RxHandler( void ){
  data=U0RXBUF;//ocitava pristigli podatak
  if (data=='4') ADC12CTL0 |= ADC12SC;                   // Start conversion
};

#pragma vector=ADC12_VECTOR
__interrupt void ADC12ISR (void)
{
  unsigned int temp;
  result = ADC12MEM0;                      // Move results, IFG is cleared
  temp=(result>>8)&0x0F;
  U0TXBUF=(0x30+temp);
  WriteLed(0x30+temp);
}